import { LocationMode } from '../LocationClientOption'; import { g1 } from "../c/e"; import geoLocationManager from '@ohos.geoLocationManager'; import { v3 } from "../i/o"; import { BDLocation } from '../BDLocation'; import { e1 } from "../c/d"; import { o2 } from "../i/j"; import { Address } from '../Address'; import map from "@hms.core.map.map"; import { Napi } from '../Napi'; import backgroundTaskManager from '@ohos.resourceschedule.backgroundTaskManager'; import { m2 } from "./g"; import { n2 } from "../c/h"; import t from "../../../../../a"; import { z2 } from "./m"; import { l2 } from "./f"; import { q2 } from "../c/k"; import { w3 } from "../c/p"; import { h3 } from "./n"; export class x3 { constructor(u4, context) { this.d1 = null; this.j3 = []; this.l3 = null; this.m3 = null; this.n3 = true; this.q3 = null; this.r3 = false; this.s3 = u4; x3.t3 = context; this.u3 = new v3(); } startLocation() { this.init(); this.y3(); } init() { l2.getInstance().init(x3.t3); z2.getInstance().h2(false); z2.getInstance().i2(); q2.z3(e1.s2, "set option! mode = " + g1.a4 + ", timeInterval = " + g1.timeInterval); } b4() { if (this.u3) { this.u3.stop(); } z2.getInstance().stop(); this.n3 = true; this.d1 = null; this.j3 = []; this.l3 = null; this.m3 = null; } c4(context, wantAgent) { try { backgroundTaskManager.startBackgroundRunning(context, backgroundTaskManager.BackgroundMode.LOCATION, wantAgent).then(() => { }).catch((error) => { console.error(`Operation startBackgroundRunning failed. code is ${error.code} message is ${error.message}`); }); } catch (error) { console.error(`Operation startBackgroundRunning failed. code is ${error.code} message is ${error.message}`); } } d4(context) { try { backgroundTaskManager.stopBackgroundRunning(context).then(() => { }).catch((error) => { console.error(`Operation stopBackgroundRunning failed. code is ${error.code} message is ${error.message}`); }); } catch (error) { console.error(`Operation stopBackgroundRunning failed. code is ${error.code} message is ${error.message}`); } } requestSingleLocation() { if (this.u3) { this.u3.requestSingleLocation((location) => { this.sendRequest(true, location); }); } } e4(option) { if (option == null) { return; } g1.l1 = option.getCoorType(); g1.timeInterval = option.getTimeInterval(); g1.distanceInterval = option.getDistanceInterval(); g1.f4 = option.getIsNeedLocationDescribe(); g1.g4 = option.getIsNeedLocationPoiList(); if (option.getIsNeedAddress()) { g1.addr = "all"; } else { g1.addr = "noaddr"; } let mode = option.getLocationMode(); if (mode != this.h4) { this.h4 = mode; if (mode == LocationMode.High_Accuracy) { g1.a4 = geoLocationManager.LocationRequestPriority.FIRST_FIX; } else if (mode == LocationMode.Battery_Saving) { g1.a4 = geoLocationManager.LocationRequestPriority.LOW_POWER; } else if (mode == LocationMode.Device_Sensors) { g1.a4 = geoLocationManager.LocationRequestPriority.ACCURACY; } if (this.s3.isStarted()) { if (this.u3) { this.u3.stop(); this.y3(); if (t.DEBUG) { q2.d(e1.s2, 'locationMode has changed, restart the location provider! mode = ' + g1.a4); } } } } g1.i4 = option.getProdName(); g1.j4 = option.l4(); } y3() { if (this.u3) { this.u3.start((location) => { this.m4(location); }); } } m4(l4) { let m4 = new BDLocation(l4); if (m4.getLongitude() == Number.MIN_VALUE && m4.getLatitude() == Number.MIN_VALUE) { this.n4(m4); return; } if (this.n3) { this.sendRequest(true, m4); } else { let n4 = 0; let o4 = 0; if (this.q3 != null) { n4 = this.q3.getLatitude(); o4 = this.q3.getLongitude(); } let p4 = { latitude: n4, longitude: o4 }; let q4 = 0; let r4 = 0; if (m4 != null) { q4 = m4.getLatitude(); r4 = m4.getLongitude(); } let s4 = { latitude: q4, longitude: r4 }; let t4 = map.calculateDistance(p4, s4); if (t.DEBUG) { q2.d(e1.s2, "processLocation oldLon：" + o4 + ", oldLat: " + n4 + ", newLon: " + r4 + ", newLat: " + q4 + ", dis: " + t4); } if (t4 < 100) { this.o4(m4); this.n4(m4); } else if (t4 < 1000) { if (this.d1 != null) { let address = new Address(this.d1.country, this.d1.countryCode, this.d1.province, this.d1.city, this.d1.cityCode, this.d1.district, null, null, this.d1.town); this.d1 = address; } this.o4(m4); this.n4(m4); this.sendRequest(false, m4); } else { this.d1 = null; this.j3 = []; this.l3 = null; this.m3 = null; this.sendRequest(true, m4); } } } o4(location) { if (g1.addr == "all") { location.setAddr(this.d1); } if (g1.f4) { location.setLocationDescribe(this.m3); } if (g1.g4) { location.setPoiRegion(this.l3); location.setPoiList(this.j3); } } sendRequest(f4, g4) { let data = o2.getInstance().q4(g4); if (t.DEBUG) { q2.d(e1.s2, 'sendRequest, data = ' + data); } let map = new Map(); map.set("bloc", Napi.r4(data)); m2.getInstance().c3(n2.s4, map, (isSuccess, result) => { if (result.includes("enc")) { try { let i4 = JSON.parse(result); let j4 = i4; if (j4) { let k4 = j4['enc'].toString(); result = h3.getInstance().decrypt(k4); if (t.DEBUG) { q2.d(e1.s2, "decrypt result = " + result); } } } catch (Error) { if (t.DEBUG) { console.error("Error: " + Error.message); } } } let h4 = new BDLocation(result); if (isSuccess) { this.q3 = g4; if (!this.r3 && h4.getCity() != null) { let city = h4.getCity(); l2.getInstance().j2("mapcity", city); this.r3 = true; } } this.t4(f4, h4, g4); }); } t4(e4, result, location) { if (result.hasAddr()) { this.d1 = result.getAddr(); location.setAddr(this.d1); } if (result.getPoiList().length != 0) { this.j3 = result.getPoiList(); location.setPoiList(this.j3); } if (result.getPoiRegion() != null) { this.l3 = result.getPoiRegion(); location.setPoiRegion(this.l3); } if (result.getLocationDescribe() != null) { this.m3 = result.getLocationDescribe(); location.setLocationDescribe(this.m3); } if (e4) { this.n4(location); } } n4(y3) { let z3 = new BDLocation(y3); let a4 = z3.getLongitude(); let b4 = z3.getLatitude(); if (a4 != Number.MIN_VALUE && b4 != Number.MIN_VALUE) { if (z3.getCoorType() == "wgs84") { let d4 = Napi.u4(a4, b4, "gps2gcj"); z3.setLongitude(d4[0]); z3.setLatitude(d4[1]); z3.setCoorType("gcj02"); a4 = z3.getLongitude(); b4 = z3.getLatitude(); } if (((z3.getCoorType() == "gcj02") || z3.getCoorType() == null) && (z3.getCoorType() != g1.l1)) { let c4 = Napi.u4(a4, b4, g1.l1); z3.setLongitude(c4[0]); z3.setLatitude(c4[1]); z3.setCoorType(g1.l1); } } if (w3.v4 && !x3.w4) { z3.setLocType(BDLocation.TYPE_SERVER_CHECK_KEY_ERROR); z3.setLocationDescribe(null); z3.setPoiList([]); z3.setPoiRegion(null); z3.setAddr(new Address()); } if (this.n3) { this.n3 = false; } this.s3.x4(z3); } static getContext() { return x3.t3; } static y4(state) { if (state == 0) { x3.w4 = true; } } } x3.w4 = false; 